// spawn-beispiele.c
// Betriebssysteme 1, v0.1, 2024-04-23

#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>

int spawnv(const char *pathname, char *const argv[]) {
  return 0;
}

int spawnve(const char *pathname, char *const argv[], char *const envp[]) {
  return 0;
}

void spawnv_test () {
  char *path = "/usr/bin/head";
  char *args[] = {
    "head",
    "-1",
    "/etc/os-release",
    NULL
  };
  spawnv (path, args);
}

void spawnve_test () {
  char *s = getenv("HOME");
  printf ("HOME = %s\n", s);

  char *path = "./printhome";
  char *args[] = { "printhome", NULL };
  char *env[] = { "HOME=/test/xyz", NULL };
  spawnve (path, args, env);
}

int main () {
  int pid;

  // spawnv-Test
  spawnv_test();

  // spawnve-Test
  spawnve_test();
}
